#include "ti86asm.inc"

;source code of Frogger 86
;version 0.99
;written by Jarno Lveri
;June 2001

cur_mode =	$f000
level_num =	$f001
surv_level =	$f002

level =	$f004
speed =	$f006
cur_lane =	$f007
time_left =	$f009
timedel =	$f00b
jumphlp =	$f00c
bjumphlp =	$f00d
frogs_saved =	$f00e
frogs_left =	$f00f

levdel =	$f010
control_delay =	$f016
loc_byte =	$f017
loc_bit =	$f019
loc_lane =	$f01a
del_loc_byte =	$f01b
del_loc_bit =	$f01d

ran1 =	$f01e
ran2 =	$f01f
lshlp =	$f020

rl_data =	$ef90

.org _asm_exec_ram

;=====install im1 grayscale routine
LoadGreyscale:
  di
  ld hl,GreyscaleRoutineStart  
  ld de,_alt_interrupt_exec  
  ld bc,gsr_end-GreyscaleRoutineStart
  ldir
  ld de,$28             
  ld a,(_alt_interrupt_exec)
  ld hl,_alt_int_chksum + $28
  add a,(hl)
  add hl,de
  add a,(hl)
  add hl,de
  add a,(hl)
  add hl,de
  add a,(hl)
  add hl,de
  add a,(hl)
  ld (_alt_int_chksum),a
  set 2,(iy + $23)                
  ei

  call _runindicoff

;### make frog sprites

 ld hl,frog
 ld b,8
makefs:
   push bc
 ld b,5
makefs2:
 or a
 rr (hl)
 inc hl
 rr (hl)
 inc hl
 djnz makefs2

 ld d,h
 ld e,l
 ld bc,10
 sbc hl,bc 
 ldir
   pop bc
 djnz makefs


;###################################
;===================================
;#####	MAIN MENU
;===================================
;###################################

 call clrscrn
 ld bc,$0803
 ld (_curRow),bc
 ld hl,t_title
 call _puts
 ld bc,$2033
 ld (_penCol),bc
 call _vputs
 call drawlogo
 call _getkey

MainMenu:
 ld a,(adv_stage)
 or a
 jr z,no_adstar
 ld a,'*'
 ld (t_adstar),a
no_adstar:
 ld a,r
 ld (ran1),a
 call clrscrn
 ld hl,t_mode
 ld b,3
 ld de,$1235
 call msloop
 ld hl,t_hs
 ld bc,$3902
 ld (_penCol),bc
 call _vputs
 ld hl,(surv_hss)
 ld bc,$393f
 call print_hl
 call drawlogo
 xor a
 ld (cur_mode),a
 inc a
 ld (speed),a
MainMenu_ck:
 call _getkey
 cp kExit
 jp z,exit
 cp kF1
 jr z,mode0
 cp kF2
 jr z,mode1
 cp kF3
 jr z,mode2
 ld b,a
 ld a,(adv_stage)
 or a
 jr z,MainMenu_ck
 ld a,b
 cp kF4
 jr nz,MainMenu_ck

mode3:
 ld b,48
 ld a,3
 jr mode12
mode2:
 ld b,97
 ld a,2
 jr mode12
mode1:
 ld b,97
 ld a,1
 ld (surv_level),a
mode12:
 ld (cur_mode),a
 ld a,b
 ld (level_num),a
 ld bc,$2a40
 ld (_penCol),bc
 ld hl,t_speed
 call _vputs
 call _getkey
 ld b,a
 ld a,$c4
 sub b
 ld (speed),a
mode0:
  

;### Reset variables for current mode

 ld a,51
 ld (frogs_left),a

 call _homeup

 ld a,(speed)
 ld hl,500
 cp 1
 jr nz,timeset
 ld hl,600
timeset:
 ld (time_left),hl


;###################################
;===================================
;#####	UNPACK AND DRAW LEVEL
;===================================
;###################################


DrawLevel:
 call clrscrn

 ld hl,frogs_saved
 xor a
 ld (hl),a

 inc hl
 ld a,(cur_mode)
 cp 1
 jr z,no_newfrogs
 cp 3
 jr z,no_newfrogs
 or a
 jr nz,newfrogs
 ld a,(adv_level)
 ld (level_num),a
 ld a,6
 jr newfrogs+2
newfrogs:
 ld a,100
 ld (hl),a 
no_newfrogs:

;### find leveldata
 
 ld a,(cur_mode)
 cp 3
 jr nz,no_rld
 ld a,r
 and $1f
 ld (ran2),a
 ld hl,(ran1)
 ld de,rl_data
 ld bc,30
 ldir
 ld hl,rl_data
 ld b,6
rld1:
 ld a,%11110011
 and (hl)
 ld (hl),a
 inc hl
 djnz rld1
 ld b,24
rld2:
 ld a,%11110111
 and (hl)
 ld (hl),a
 inc hl
 djnz rld2
 ld hl,rl_data
 ld (level),hl
 jr ld_done
no_rld:
 ld a,(level_num)
 sub 96
 ld b,a
 ld hl,levela
 ld de,levelsizes
find_ldata:
 ld a,(de)
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 inc de
 djnz find_ldata
 ld (level),hl
ld_done:

;### waterlanes

 ld de,$fc80
 ld b,6
draw_water:
   push bc
 ld a,(hl)
 and %111
 cp %111
 jr z,no_waterlane	;kyseess juna
 ld a,(hl)
 and %1000
 jr z,no_waterlane
   push hl
   push de
 ld h,d
 ld l,e
 ld bc,$3200
 sbc hl,bc		;hl =gs, de =ts
 ld b,8
 ld c,%10101010
water1:
 rlc c
 push bc
 ld b,16
water2:
 ld a,%11111111
 ld (de),a
 inc de
 ld a,c
 ld (hl),a
 inc hl
 djnz water2
 pop bc
 djnz water1
   pop de
   pop hl
no_waterlane:
 ex de,hl
 ld bc,$80
 add hl,bc
 ex de,hl  
 inc hl
 pop bc
 djnz draw_water

;### Draw traffic on screen

 ld hl,(level)
 ld bc,6
 add hl,bc
 ld de,$fc80
 xor a
drawlevel1:
 ld (cur_lane),a
   push de
   push hl		;hl = level datan alku+6, eli vars. autot.
 ld hl,(level)
 ld c,a
 ld b,0
 add hl,bc	;hl = ko. kaistan datan alku
 ld a,(hl)
 and %111	;a = autojen mr
   pop hl
 ld b,a
 or a
 jr z,skip_drawlevel
 inc b
drawlevel2:
   push bc
 ld a,(hl)
 and %1111
 ld b,a
 inc b
   push hl
   push de
 ld hl,car1-28
 ld de,28
drawl_loop:
 add hl,de
 djnz drawl_loop	;hl = auton spriten abs.addr.
   pop de
   push de
 ex de,hl		;de = sprite addr., hl = screenloc.
 ld b,7
  push hl
 call putsprite
 ld bc,$326f
 sbc hl,bc
 ld b,7
 call putsprite
  pop hl
 inc hl
 ld b,7
 call putsprite
 ld bc,$326f
 sbc hl,bc
 ld b,7
 call putsprite 
   pop de
   pop hl
   push de
   push hl 
 ld a,(hl)
 rra
 rra
 rra
 rra
 and %1111
 add a,a
 add a,a
 add a,16
 ld b,a
dl_scroll:
 push bc
 call sright
 pop bc
 djnz dl_scroll
   pop hl
   pop de
 inc hl
   pop bc
 djnz drawlevel2
skip_drawlevel:
   pop de
 ex de,hl
 ld bc,$80
 add hl,bc
 ex de,hl  
 ld a,(cur_lane)
 inc a
 cp 6
 jr nz,drawlevel1



;### mirrored lanes

 ld de,$fc8f
 ld hl,(level)
 ld b,6
editlanes:
 push bc
 ld a,(hl)
 and %10000
 jr z,no_mirlane
   push hl
   push de
 ex de,hl 
 call mirror
   pop de
   pop hl
no_mirlane:
 inc hl
 ex de,hl
 ld bc,$80
 add hl,bc
 ex de,hl
 pop bc
 djnz editlanes


;### level txt

 ld bc,$3965
 ld (_penCol),bc
 ld hl,t_level
 call _vputs
 ld a,(level_num)
 call _vputmap



;### level select

 ld a,(cur_mode)
 cp 2
 jr nz,no_levelselect
levelselect:
 ld a,(adv_level)
 ld e,a
 ld a,(adv_stage)
 or a
 jr z,anc
 ld e,116
anc:
 ld a,e
 ld (lshlp),a
 ld bc,0
 ld (_penCol),bc
 ld hl,t_levsel
 call _vputs
 call _getkey
 cp kExit
 jp z,MainMenu
 cp kEnter
 jr z,no_levelselect
 cp kLeft
 jr z,prev_level
 cp kRight
 jr nz,levelselect

next_level:
 ld a,(lshlp)
 ld e,a
 inc e
 ld a,(level_num)
 inc a
 cp e
 jr nz,no_firstlevel
 ld a,97
no_firstlevel:
 ld (level_num),a
 jp DrawLevel

prev_level:
 ld a,(level_num)
 dec a
 cp 96
 jr nz,no_lastlevel
 ld a,(lshlp)
no_lastlevel:
 ld (level_num),a
 jp DrawLevel
no_levelselect:



;###################################
;===================================
;#####	ENGINE
;===================================
;###################################

GameStart:

;### Frog pics $ texts etc
 ld hl,$fc00
 ld de,$fc01
 ld bc,$6f
 ldir

 ld hl,$ca10
 ld b,5
drawfrogsup:
 push bc
 push hl
 ld de,frog
 ld b,5
dfup2:
 ld a,(de)
 ld (hl),a
 call s16ba
 inc de
 inc de
 djnz dfup2
 pop hl
 inc hl
 pop bc
 djnz drawfrogsup
 ld a,$f0
 cp h
 jr c,no_futs
 ld a,(frogs_saved)
  push af
 cp 0
 jr z,no_futs
 ld b,a
 ld hl,$fc10
 jr drawfrogsup
no_futs:
  pop af
 cp 5
 jp z,level_completed 

 ld bc,$3905
 ld a,(frogs_left)
 dec a
 jp z,gameover
 ld (frogs_left),a
 ld l,a
 ld h,0
 call print_hl
 ld hl,$ffa0
 ld de,frog
 ld b,5
dfdwn:
 ld a,(de)
 ld (hl),a
 call s16ba
 inc de
 inc de
 djnz dfdwn

 ld bc,64
 ld (_penCol),bc

 ld hl,reset_vars
 ld de,levdel
 ld bc,14
 ldir


;### engine

 xor a
engine:
 ld (cur_lane),a
 ld c,a
 ld b,0
 ld hl,(level)
 add hl,bc
 ld a,(hl)
 and %11100000
 jp z,no_movethislane
 ld a,(hl)
 rra
 rra
 rra
 rra
 and %1111
 ld b,a			;b = kaistan liikenopeus & -suunta
   push bc
 ld hl,levdel
 ld a,c
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld a,(hl)
 inc a
 ld (hl),a		;a = lane delay tll hetkell
 srl b
 cp b
   pop bc
 jp nz,no_movethislane
 xor a
 ld (hl),a
   push bc	;for scrolling
   push bc	;for erase frog -info

;###

 ld a,(timedel)
 ld c,a
 inc c
 ld a,(speed)
 cp 2
 jr nz,no_speeddel2
 halt
 inc c
no_speeddel2:
 or a
 jr z,no_speeddel
 halt
 inc c
 inc c
no_speeddel:
 ld a,c
 cp 250
 jr c,no_dectime
 ld hl,(time_left)
 dec hl
 ld a,h
 or a
 jr nz,dectime
 ld a,l
 cp 0
 jr z,no_dectime-1
dectime:
 ld (time_left),hl
 xor a
no_dectime: 
 ld (timedel),a


;control frog
 ld a,(control_delay)
 inc a
 cp 3	;control sensitivity
 jp nz,no_control 
 ld a,%11111110
 out (1),a
 in a,(1)
 bit 2,a
 push af
 call z,go_right
 pop af
 bit 1,a
 call z,go_left
kc_end:
 xor a
no_control:
 ld (control_delay),a


 pop bc
;erase frog -info 
 ld a,(loc_lane)
 ld c,a
 ld a,(cur_lane)
 cp c
 jr nz,efi_end
 ld a,(cur_lane)
 ld hl,(level)
 ld e,a
 ld d,0
 add hl,de
 ld a,(hl)
 and %1000
  push af
 srl b
 jr nc,delbit_right
delbit_left:
  pop af
 call nz,go_left
 ld a,(del_loc_bit)
 dec a
 cp -1
 jr nz,dbl_non
 ld hl,(del_loc_byte)
 dec hl
 ld (del_loc_byte),hl
 ld a,7
dbl_non:
 ld (del_loc_bit),a
 jr efi_end
delbit_right:
  pop af
 call nz,go_right
 ld a,(del_loc_bit)
 inc a
 cp 8
 jr nz,dbl_no8
 ld hl,(del_loc_byte)
 inc hl
 ld (del_loc_byte),hl
 xor a
dbl_no8:
 ld (del_loc_bit),a
efi_end:

   pop bc
;scroll current lane
 sra b
 jr nc,mtl_right
 call sleft
 jr mtl_end
mtl_right:
 call sright
mtl_end:

;frog
 call erasefrog

;jump if 2nd pressed
checkjumpkey:
 ld a,%10111111
 out (1),a
 in a,(1)
 bit 5,a
 jr z,jump
 bit 7,a
 jr z,pause
 ld a,%11111110
 out (1),a
 in a,(1)
 bit 3,a
 jr z,jump 
 jr no_jump
pause:
 call _getkey
 cp kExit
 jp z,MainMenu
 cp kAdd
 push af
 push af
 call z,contplus
 pop af
 cp kSub
 call z,contminus
 pop af
 cp kEnter
 jr nz,pause
 jr no_jump
jump:
 ld a,(jumphlp)
 cp 1
 jr z,no_jump2
 ld a,(loc_lane)
 dec a
 ld (loc_lane),a
 cp -1
 jp z,frog_saved
 ld hl,(loc_byte)
 ld de,$7f
 sbc hl,de
 ld (loc_byte),hl
 ld a,1
 jr no_jump2-3
no_jump: 
 xor a
 ld (jumphlp),a
no_jump2:

;bjump if Alpha pressed
checkbjumpkey:
 ld a,%11011111
 out (1),a
 in a,(1)
 bit 7,a
 jr z,bjump
 ld a,%11111110
 out (1),a
 in a,(1)
 bit 0,a
 jr nz,no_bjump
bjump:
 ld a,(bjumphlp)
 cp 1
 jr z,no_bjump2
 ld a,(loc_lane)
 inc a
 cp 7
 jr z,no_bjump
 ld (loc_lane),a
 ld hl,(loc_byte)
 ld de,$80
 add hl,de
 ld (loc_byte),hl
 ld a,1
 jr no_bjump2-3
no_bjump: 
 xor a
 ld (bjumphlp),a
no_bjump2:


;draw frog
drawfrog:
 ld hl,frog
 ld a,(loc_bit)
 ld (del_loc_bit),a
 add a,a
 ld b,a
 add a,a
 add a,a
 add a,b
 ld c,a
 ld b,0
 add hl,bc
 ex de,hl	;de = frogsprite
 ld hl,(loc_byte)	;hl = sijainti nytll
 ld (del_loc_byte),hl
   push hl
   push de
 ld b,5
checkfrog:
 ld a,(de)
 and (hl)
 jp nz,frog_dead
 inc hl
 inc de
 ld a,(de)
 and (hl)
 jp nz,frog_dead
 inc de
 call s16ba
 dec hl
 djnz checkfrog
   pop de
   pop hl
 ld b,5
drawfrog2:
 ld a,(de)
 or (hl)
 ld (hl),a
 inc hl
 inc de
 ld a,(de)
 or (hl)
 ld (hl),a
 inc de
 call s16ba
 dec hl
 djnz drawfrog2

;###

no_movethislane:

;end of engine
 ld a,(cur_lane)
 inc a
 cp 6
 jp nz,engine
 xor a
 jp engine

;### new frog / level completed

frog_dead:
 pop hl
 pop hl
 ld hl,t_fk
 call _vputs
 call wait
 ld a,(cur_mode)
 or a
 jp nz,GameStart

gameover:
 ld bc,64
 ld (_penCol),bc
 ld hl,t_go
 call _vputs
 call _getkey
 jp MainMenu

frog_saved:
 ld hl,t_fs
 call _vputs
 ld a,(frogs_saved)
 inc a
 ld (frogs_saved),a
 call wait
 jp GameStart

level_completed:
 ld a,(cur_mode)
 cp 2
 jp z,MainMenu
 cp 3
 jr nz,lc_cont
 ld a,(level_num)
 inc a
 ld (level_num),a
 jp DrawLevel
lc_cont:
 or a
 jr nz,surv_nextl
 ld a,(adv_level)
 inc a
 ld (adv_level),a
 cp 117
 jp nz,DrawLevel

adventure_completed:
 ld a,97
 ld (adv_level),a
 ld (adv_stage),a
 call clrscrn
 ld bc,$1933
 ld (_penCol),bc
 ld hl,t_advc
 call _vputs
 ld bc,$2033
 ld (_penCol),bc
 call _vputs
 call drawlogo
 call _pause
 jp MainMenu

surv_nextl:
 ld a,(surv_level)
 inc a
 cp 6
 jr z,survival_completed
 ld (surv_level),a
 ld hl,surv_levlist-1
 ld c,a
 ld b,0
 add hl,bc
 ld a,(hl)
 ld (level_num),a
 jp DrawLevel

survival_completed:
 call clrscrn
 ld hl,t_survpoints
 ld b,4
 ld de,$1035
 call msloop
 ld a,(frogs_left)
 ld l,a
 ld h,0
 add hl,hl
 ld d,h
 ld e,l
 add hl,hl
 add hl,hl
 add hl,de
 ld bc,$1055
   push hl
 call print_hl
 ld hl,(time_left)
 ld bc,$1855
   push hl
 ld a,l
 or a
 jr z,no_print_time
 ld a,h
 or a
 call nz,print_hl
no_print_time:
 ld a,(speed)
 ld b,a
 ld a,3
 sub b
 ld b,a
 xor a
 ld h,a
x100:
 add a,100
 djnz x100
 sub 100
 ld l,a
 ld bc,$1f55
   push hl
 or a
 call nz,print_hl
 ld hl,0
   pop de
 add hl,de
   pop de
 add hl,de
   pop de
 add hl,de
 ld bc,$2755
 push hl
 call print_hl
 call drawlogo
 call _pause
 pop hl
 ld de,(surv_hss)
 ld a,d
 cp h
 jr c,new_high
 jp nz,MainMenu
 ld a,(surv_hss+1)
 ld a,e
 cp l
 jp nc,MainMenu
new_high:
 ld (surv_hss),hl
 ld bc,$3128
 ld (_penCol),bc
 ld hl,t_inits
 call _vputs
 ld c,0
init_loop:
 ld hl,surv_hs
 ld a,67
 ld (_penCol),a
 call _vputs
 call _getkey
 cp kEnter
 jp z,MainMenu
 ld hl,surv_hs
 ld b,0
 add hl,bc
 cp kUp
 jr z,i_next
 cp kDown
 jr z,i_prev
 cp kRight
 jr nz,init_loop
 inc c
 ld a,3
 cp c
 jr nz,init_loop
 jr init_loop-2
i_next:
 ld a,(hl)
 inc a
 ld (hl),a
 cp 214
 jr nc,i_next
 jr init_loop
i_prev:
 ld a,(hl)
 dec a
 ld (hl),a
 cp 214
 jr nc,i_prev
 jr init_loop

 


;###################################
;===================================
;#####	VARIABLES
;===================================
;###################################

;fixed
surv_levlist:
.db 97,98,108,109,113

reset_vars:
.db 0,0,0,0,0,0,0
.dw $ff97
.db 3,6
.dw $ff97
.db 3

;text
t_title:
.db "Frogger 86",0
.db "by  Jarno Laaveri",0
t_mode:
.db "F1..adventure "
t_adstar:
.db " ",0
.db "F2..survival",0
.db "F3..level",0
t_inits:
.db "initials:",0
t_speed:
.db "F1-F3..speed",0
t_levsel:
.db "< >select level",0
t_level:
.db "level  ",0
t_fs:
.db "frog saved!",0
t_fk:
.db "frog killed",0
t_go:
.db "Game Over!",0
t_advc:
.db "Congratulations!",0
.db "adventure completed",0
t_survpoints:
.db "frogs:",0
.db "time:",0
.db "speed",0
.db "total:",0

;saved data
sd_start:
adv_level:
.db 97
adv_stage:
.db 0
t_hs:
.db "survival  hs:   "
surv_hs:
.db "JTL  ",0
surv_hss:
.dw 250
sd_end:


;###################################
;===================================
;#####	CALLS
;===================================
;###################################


;=====
exit:
 call CloseGrey
 call clrscrn
 call _clrScrn
	ld hl,_asapvar	;save game -routine by Jimi Malcolm
	rst 20h				
	rst 10h			
	ld a,b		
	ld hl,sd_start-_asm_exec_ram+4
	add hl,de	
	adc a,$00		
	call _set_abs_dest_addr						
	xor a			
	ld hl,sd_start
	call _set_abs_src_addr
	ld hl,sd_end-sd_start
	call _set_mm_num_bytes
	call _mm_ldir
 jp _homeup

;=====
contminus:
 ld hl,$c008
 ld a,(hl)	
 cp 0	
 ret z		
 dec a	
 ld (hl),a	
 out (2),a
 xor a
 ret

;=====
contplus:
 ld hl,$c008
 ld a,(hl)	
 cp 31	
 ret z		
 inc a	
 ld (hl),a	
 out (2),a
 xor a
 ret

;====
msloop:
 ld (_penCol),de
 ld a,d
 add a,8
 ld d,a
 call _vputs
 djnz msloop
 ret

;====
print_hl:
 ld (_penCol),bc
 push bc
 ld de,0
 ld c,d		;cde=0
print_hl2:
 inc e
 ld a,10
 cp e
 jr nz,print_hl2cont
 ld e,0
 inc d
 cp d
 jr nz,print_hl2cont
 ld d,0
 inc c
print_hl2cont:
 dec hl
 ld a,l
 or a
 jr nz,print_hl2
 ld a,h
 or a
 jr nz,print_hl2
 ld a,c
 add a,48
 push de
 call _vputmap
 pop hl
 pop bc
 ld a,4
 add a,c
 ld c,a
 ld (_penCol),bc
 push bc
 ld a,h
 add a,48
 call _vputmap
 pop bc
 ld a,4
 add a,c
 ld c,a
 ld (_penCol),bc
 ld a,l
 add a,48
 call _vputmap
 ret


;=====
go_right:
 ld a,(loc_bit)
 inc a
 cp 8
 jr nz,gl_no8
 ld hl,(loc_byte)
 inc hl
 ld a,l 
 and $f
 cp $f
 ret z
 ld (loc_byte),hl
 xor a
gl_no8:
 ld (loc_bit),a
 ret

;=====
go_left:
 ld a,(loc_bit)
 dec a
 cp -1
 jr nz,gl_non
 ld hl,(loc_byte)
 dec hl
 ld a,l 
 and $f
 cp $f
 ret z
 ld (loc_byte),hl
 ld a,7
gl_non:
 ld (loc_bit),a
 ret

;=====
wait:
 ld b,120
 halt
 djnz wait+2
 ret

;=====
mirror:
 push hl
 push hl
 push hl
 ld de,vopc+101
 ld hl,vopc+100
 xor a
 ld (hl),a
  push hl
 ld bc,128
 ldir
  pop de	;de = vopc-osoite
 pop hl		;hl = tavu (nytss), joka peilataan
 ld b,8		;8 rivi
mir1:
 push bc
 ld b,16	;16 tavua/rivi
mir2:
 push bc
 ld b,8		;8 bitti/tavu
 ld c,%10000000
mir3:
 rr (hl)
 jr nc,mir_j1
 ex de,hl
 ld a,(hl)
 or c
 ld (hl),a
 ex de,hl
mir_j1:
 rr c
 djnz mir3
 pop bc
 dec hl
 inc de
 djnz mir2 
 ld bc,32
 add hl,bc
 pop bc 
 djnz mir1
 pop de
 ld a,e
 sub 15
 ld e,a
 ld hl,vopc+100
 ld bc,128
 ldir
 pop hl
 ld a,$f0
 cp h
 ret nc
 ld de,$31ff
 sbc hl,de
 jr mirror

;====
sleft:
 ld a,(cur_lane)
 inc a
 ld b,a
 ld hl,$fc7f
 ld de,$80
sleftl:
 add hl,de
 djnz sleftl
sleft0:
 push hl
 ld b,8
sleft1:
 push bc
 ld b,16
 or a
sleft2:
 rl (hl)
 dec hl
 djnz sleft2
 ld a,0
 jr nc,sleft3
 inc a
sleft3:
 push hl
 ld de,16
 add hl,de
 or (hl)
 ld (hl),a
 pop hl
 pop bc
 djnz sleft1
 pop hl
 ld a,$f0
 cp h
 ret nc
 ld de,$31ff
 sbc hl,de
 jr sleft0

;====
sright:
 ld a,(cur_lane)
 inc a
 ld b,a
 ld hl,$fbf0
 ld de,$80
srightl:
 add hl,de
 djnz srightl
sright0:
 push hl
 ld b,8
sright1:
 push bc
 ld b,16
 or a
sright2:
 rr (hl)
 inc hl
 djnz sright2
 ld a,0
 jr nc,sright3
 ld a,%10000000
sright3:
 push hl
 ld de,15
 sbc hl,de
 or (hl)
 ld (hl),a
 pop hl
 pop bc
 djnz sright1
 pop hl
 ld a,$f0
 cp h
 ret nc
 ld de,$31ff
 sbc hl,de
 jr sright0

;=====
clrscrn:
  call _clrScrn
  ld hl,$fc00            ;clear the memory at $fc00...
  ld (hl),l
  ld de,$fc01
  ld bc,1023
  ldir
copyscrns:
  ld hl,$fc00            ;...and the memory at $ca00
  ld de,$ca00
  ld bc,1024
  ldir
  ret

;=====
s16ba:
 ld a,16
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ret

;=====
putsprite:	
 ld a,(de)
 ld (hl),a
 call s16ba
 inc de
 djnz putsprite
 ret

;=====
erasefrog:
 ld hl,frog
 ld a,(del_loc_bit)
 add a,a
 ld b,a
 add a,a
 add a,a
 add a,b
 ld c,a
 ld b,0
 add hl,bc
 ex de,hl	;de = frogsprite
 ld hl,(del_loc_byte)	;hl = sijainti nytll
 ld b,5
erasefrog2:
 ld a,(de)
 cpl
 and (hl)
 ld (hl),a
 inc hl
 inc de
 ld a,(de)
 cpl
 and (hl)
 ld (hl),a
 inc de
 call s16ba
 dec hl
 djnz erasefrog2
 ret

;=====
drawlogo:
 call copyscrns
 ld hl,0
 ld c,64
scrollmenu:
 ld b,16
 or a
scrollmenu2:
 dec hl
 rl (hl)
 djnz scrollmenu2
 dec c
 jr nz,scrollmenu
 ld hl,$fd02
 ld de,logo
drawlogo1:
 ld c,31
drawlogo2:
 push hl
 ld b,4
drawlogo3:
 ld a,(de)
 ld (hl),a
 inc hl
 inc de
 djnz drawlogo3
 pop hl
 call s16ba
 dec c
 jr nz,drawlogo2
 ld a,$f0
 cp h
 ret nc
 ld hl,$cb02
 jr drawlogo1

logo:
 .db %00000000,%00000000,%00000000,%00010000
 .db %00000000,%00000000,%00000101,%00011000
 .db %00000000,%00000000,%00001000,%01011100
 .db %00000000,%00000000,%00000001,%11110100
 .db %00000000,%00000000,%00000001,%11111100
 .db %00000000,%00000000,%00000001,%11111100
 .db %00000000,%00000000,%00001011,%11111000
 .db %00000000,%00000000,%00011111,%11111000
 .db %00000000,%00000000,%00101011,%11110000
 .db %00000000,%00000000,%00111011,%11110000
 .db %00000000,%00000101,%11111111,%11110000
 .db %00000000,%00000000,%01111111,%11100000
 .db %00000000,%00010101,%11111111,%11100000
 .db %00000000,%00000011,%11111111,%11000000
 .db %00000000,%00000111,%10111111,%11000000
 .db %00000000,%00101111,%11111111,%11000000
 .db %00000000,%00011111,%11111111,%11000000
 .db %00000100,%00111111,%11111111,%01100000
 .db %00001001,%10111111,%11111111,%01000000
 .db %00001000,%01111111,%11111111,%01100110
 .db %00001001,%01111111,%11111110,%01110111
 .db %00010111,%11111111,%11111100,%10111110
 .db %00110011,%11111011,%11111000,%01111110
 .db %00101110,%11111101,%11111111,%00111110
 .db %11101111,%10010100,%11111111,%10000000
 .db %00011001,%00100111,%11111111,%00000000
 .db %00011001,%10111111,%11111111,%00110000
 .db %00010011,%11111111,%11111111,%11100000
 .db %00001111,%11111111,%11111111,%11111000
 .db %00000011,%11111111,%11111111,%00000000
 .db %00000000,%01111111,%11110000,%00000000

 .db %00000000,%00000000,%00011100,%11101000
 .db %00000000,%00000000,%00111010,%11111100
 .db %00000000,%00000000,%00110111,%10110000
 .db %00000000,%00000000,%00111110,%11101100
 .db %00000000,%00000000,%00111111,%11110000
 .db %00000000,%00000000,%01111111,%11100000
 .db %00000000,%00000000,%01100101,%11101000
 .db %00000000,%00000001,%11100001,%11010000
 .db %00000000,%00000011,%01010111,%10010000
 .db %00000000,%00000111,%11000111,%01110000
 .db %00000000,%00001010,%00000010,%01100000
 .db %00000000,%00111111,%10001010,%01110000
 .db %00000000,%01101010,%00000111,%11100000
 .db %00000001,%11111100,%01000011,%11000000
 .db %00000011,%10111000,%01001111,%11000000
 .db %00000110,%11010011,%01011111,%11000000
 .db %00001111,%11100101,%00001111,%00100000
 .db %00011011,%11001110,%11010110,%11000000
 .db %00010110,%01011101,%00000110,%10100000
 .db %00110111,%10111000,%01011111,%10100000
 .db %00110110,%10110100,%10011111,%10111010
 .db %01101000,%01101110,%10011110,%11111111
 .db %11001100,%11110101,%00010100,%11111110
 .db %01010001,%10000010,%00001001,%11011100
 .db %00010000,%01101011,%00001111,%00001100
 .db %11110110,%11011000,%00111111,%10000000
 .db %00100110,%01001001,%01111111,%11110000
 .db %00101100,%00000001,%11111111,%11100000
 .db %00000011,%11111111,%11111111,%11100000
 .db %00000111,%11111111,%11111111,%11000000
 .db %00000001,%10111111,%11101000,%00000000



;###################################
;===================================
;#####	LEVEL DATA
;===================================
;###################################

levela:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10110001
.db %11100000
.db %11000010
.db %11100000
.db %11110001
.db %11100000
.db $87,$96
.db $53,$61,$40
.db $d7,$a2

levelb:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10110010
.db %10000001	
.db %11100000	
.db %11010010
.db %11100011	
.db %11100000
.db $52,$57,$54
.db $70,$83
.db $46,$67,$51
.db $57,$51,$53,$04

levelc:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01111001
.db %10101010
.db %11111011
.db %11100000
.db %10000001
.db %11100010
.db $0f,$1f
.db $8f,$7f,$9f
.db $0f,$bf,$0f,$0f
.db $a7,$b2
.db $86,$83,$84

leveld:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01111111
.db %00000000
.db %01000010
.db %10110011
.db %10000011
.db %11100011
.db 8,9,9,10,9,10,11,11
.db $e,$d,$4c
.db $e,$6c,$57,$45
.db $66,$e,$d,$6c
.db $e,$d,$9c,21


levele:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00100010
.db %00110010
.db %00000000
.db %01101001
.db %10011001
.db %10001010
.db $82,$91,$27
.db $86,$70,$96
.db $6f,$cf
.db $0f,$df
.db $8f,$7f,$af

levelf:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10000000
.db %01011001
.db %01111001
.db %10011001
.db %11000010
.db %11010010
.db $0f,$df
.db $0f,$df
.db $0f,$df
.db $80,$97,$41
.db $95,$81,$22

levelg:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01010010
.db %10110010
.db %01101001
.db %01110010
.db %11010010
.db %01101001
.db $72,$71,$37
.db $75,$76,$70
.db $0f,$bf
.db $77,$74,$01
.db $75,$72,$63
.db $0f,$bf

levelh:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10110010
.db %01110010
.db %01010010
.db %01000001
.db %01100001
.db %10100010
.db $91,$83,$35
.db $92,$87,$01
.db $94,$82,$20
.db $c7,$81
.db $b1,$62
.db $95,$83,$a4

leveli:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01111001
.db %01101001
.db %11111111
.db %11101111
.db %01111001
.db %01101001
.db $cf,$5f
.db $cf,$0f
.db 8,9,9,10,9,11,11,11
.db 11,8,10,9,9,10,10,9
.db $cf,$ff
.db $cf,$8f

levelo:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00101001
.db %11011001
.db %10011001
.db %01101001
.db %10101001
.db %10111001
.db $0f,$ff
.db $0f,$ff
.db $0f,$ff
.db $0f,$ff
.db $0f,$ff
.db $0f,$ff

levelj:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01100010
.db %10001001
.db %10001001
.db %10001001
.db %10001001
.db %01100010
.db $81,$76,$43
.db $0f,$ff
.db $0f,$bf
.db $0f,$6f
.db $0f,$1f
.db $76,$87,$90

leveln:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10100010
.db %10100011
.db %10100010
.db %10100010
.db %10100011
.db %10100010
.db $62,$67,$35
.db $45,$41,$51,34
.db $52,$73,$20
.db $71,$37,$65
.db $55,$51,$41,$06
.db $22,$93,$73

levelt:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01011010
.db %01101010
.db %10011010
.db %10101010
.db %11011010
.db %11101010
.db $6f,$6f,$3f
.db $6f,$6f,$2f
.db $6f,$6f,$5f
.db $6f,$6f,$6f
.db $6f,$6f,$0f
.db $6f,$6f,$0f

levelr:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00000111
.db %01100001
.db %00000111
.db %01100001
.db %00000111
.db %01100001
.db 11,11,8,10,10,9,9,11
.db $d5,$a1
.db 11,11,8,10,9,10,10,11
.db $d7,$20
.db 10,11,9,9,11,11,8,10
.db $d3,$70

levelk:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01110011
.db %00100011
.db %01001001
.db %11101001
.db %01110011
.db %10000011
.db $41,$57,$51,$15
.db $46,$42,$30,$54
.db $0f,$8f
.db $0f,$ff
.db $43,$41,$47,$46
.db $41,$52,$41,$35

levelp:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00000000
.db %00000100
.db %00100001
.db %00110001
.db %00000000
.db %00000000
.db $21,$20,$36,$27,$25
.db $d1,$77
.db $e6,$15

levelq:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00001001
.db %00001001
.db %01110001
.db %01110001
.db %00001001
.db %01100000
.db $cf,$8f
.db $8f,$cf
.db $c5,$91
.db $d7,$12
.db $0f,$0f

levell:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %01000011
.db %01110011
.db %10000011
.db %01010011
.db %10100011
.db %01110011
.db $46,$42,$41,$27
.db $43,$40,$45,$14
.db $42,$46,$41,$47
.db $40,$43,$41,$35
.db $45,$46,$47,$54
.db $46,$45,$40,$40

levelm:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %10101001
.db %10111001
.db %01110011
.db %01100100
.db %10101001
.db %10111001
.db $1f,$6f
.db $1f,$af
.db $46,$35,$51,$42
.db $47,$0e,$0d,$0c,$53
.db $1f,$9f
.db $1f,$0f

levels:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %11101001
.db %10110101
.db %10000100
.db %01110011
.db %01000010
.db %00110001
.db $df,$ff
.db $12,$25,$22,$15,$27,$11
.db $25,$27,$34,$21,$20
.db $43,$41,$46,$2
.db $64,$67,$21
.db $d7,$d1

;survival only -levels:





levelsizes:
     ; a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u  v  w  x  y  z
.db 0,13,18,20,29,19,18,22,22,30,18,20,26,24,36,26,15,16,30,23,28











;###################################
;===================================
;#####	PICS
;===================================
;###################################

;===
car1:
  .db %11111111
  .db %11110101
  .db %10010101
  .db %10010101
  .db %11110101
  .db %11111111
  .db %00000000

  .db %11111111
  .db %10011111
  .db %10011111
  .db %10011011
  .db %10011011
  .db %11111111
  .db %00000000

  .db %11110000
  .db %11110000
  .db %10010000
  .db %10010000
  .db %11110000
  .db %11110000
  .db %00000000

  .db %11100000
  .db %10010000
  .db %10010000
  .db %10010000
  .db %10010000
  .db %11100000
  .db %00000000

;===
car2:
  .db %11111111
  .db %11111111
  .db %11111111
  .db %11111111
  .db %11111111
  .db %11111111
  .db %00000000

  .db %01111111
  .db %10110011
  .db %10110001
  .db %10110001
  .db %10110011
  .db %01111111
  .db %00000000

  .db %11100000
  .db %11010000
  .db %11110000
  .db %11110000
  .db %11010000
  .db %11100000
  .db %00000000

  .db %11100000
  .db %00110000
  .db %10010000
  .db %10010000
  .db %00110000
  .db %11100000
  .db %00000000

;===
car3:
  .db %00000000
  .db %11111111
  .db %10011001
  .db %10101010
  .db %10101000
  .db %10011001
  .db %11111111

  .db %00000000
  .db %01111111
  .db %10010001
  .db %10110000
  .db %10110000
  .db %10010001
  .db %01111111

  .db %00000000
  .db %11110000
  .db %10001000
  .db %11001000
  .db %11001000
  .db %10001000
  .db %11110000

  .db %00000000
  .db %11111000
  .db %01001000
  .db %10101000
  .db %10101000
  .db %01001000
  .db %11111000

;===
car4:
  .db %01111111
  .db %01000001
  .db %01000001
  .db %11000001
  .db %11000001
  .db %11000001
  .db %01111111

  .db %01111111
  .db %01000001
  .db %01111111
  .db %01000001
  .db %11111111
  .db %01000001
  .db %01111111

  .db %11111000
  .db %01100100
  .db %00110100
  .db %00110100
  .db %00110100
  .db %01100100
  .db %11111000

  .db %11111100
  .db %00110100
  .db %00100100
  .db %00110100
  .db %00100100
  .db %00110100
  .db %11111100

;===
car5:
  .db %00000000
  .db %11111111
  .db %11001111
  .db %11001111
  .db %11001111
  .db %11001111
  .db %11111111

  .db %00000000
  .db %01111000
  .db %11011111
  .db %11011111
  .db %11011111
  .db %11011111
  .db %01111000

  .db %00000000
  .db %11111100
  .db %10011110
  .db %11001110
  .db %11001110
  .db %10011110
  .db %11111100

  .db %00000000
  .db %11111010
  .db %11011100
  .db %11101110
  .db %11101110
  .db %11011100
  .db %11111010

;===
car6:
  .db %00000000
  .db %11111111
  .db %10100011
  .db %10100011
  .db %10100011
  .db %10100011
  .db %11111111

  .db %00000000
  .db %00000000
  .db %01010010
  .db %01010011
  .db %01010011
  .db %01010010
  .db %00000000

  .db %00000000
  .db %11000000
  .db %00100000
  .db %00100000
  .db %00100000
  .db %00100000
  .db %11000000

  .db %00000000
  .db %00100000
  .db %00000000
  .db %00000000
  .db %00000000
  .db %00000000
  .db %00100000

;===
car7:
  .db %00000000
  .db %01111111
  .db %10110001
  .db %10111111
  .db %10111111
  .db %10110001
  .db %01111111

  .db %00000000
  .db %10000000
  .db %00010000
  .db %01010000
  .db %01010000
  .db %00010000
  .db %10000000

  .db %00000000
  .db %11110000
  .db %10001000
  .db %11001000
  .db %11001000
  .db %10001000
  .db %11110000

  .db %00000000
  .db %00001000
  .db %11000000
  .db %11110000
  .db %11110000
  .db %11000000
  .db %00001000

car8:
 .db %01111111
 .db %01010011
 .db %01010001
 .db %01010001
 .db %01010011
 .db %01111111
 .db %00000000

 .db %00111111
 .db %01110011
 .db %01100011
 .db %01100011
 .db %01110011
 .db %00111111
 .db %00000000

 .db %11100000
 .db %00110000
 .db %10010000
 .db %10010000
 .db %00110000
 .db %11100000
 .db %00000000

 .db %10010000
 .db %10010000
 .db %10010000
 .db %10010000
 .db %10010000
 .db %10010000
 .db %00000000

train1:	;steam locomotive
 .db %11101101
 .db %11111111
 .db %11111001
 .db %11111111
 .db %11111001
 .db %11111111
 .db %11101101

 .db %11111001
 .db %11101000
 .db %11110111
 .db %11111010
 .db %11110111
 .db %11101000
 .db %11111001

 .db %10110000
 .db %11111111
 .db %00011100
 .db %11111110
 .db %00011100
 .db %11111111
 .db %10110000

 .db %00100000
 .db %00011000
 .db %11101010
 .db %10001100
 .db %11101010
 .db %00011000
 .db %00100000

train2	;rail car
 .db %11111111
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %11111111

 .db %01111111
 .db %11101110
 .db %10010001
 .db %11101110
 .db %10010001
 .db %11101110
 .db %01111111

 .db %11111100
 .db %00000100
 .db %00000101
 .db %00000110
 .db %00000101
 .db %00000100
 .db %11111100

 .db %11111000
 .db %11101100
 .db %00010110
 .db %11101111
 .db %00010110
 .db %11101100
 .db %11111000

train3: ;rail car2
 .db %11010101
 .db %10000000
 .db %11111111
 .db %11101101
 .db %11111111
 .db %10000000
 .db %11010101

 .db %01111111
 .db %11111111
 .db %10000000
 .db %11101101
 .db %10000000
 .db %11111111
 .db %01111111

 .db %01010110
 .db %00000010
 .db %11111111
 .db %10110110
 .db %11111111
 .db %00000010
 .db %01010110

 .db %11111100
 .db %11111110
 .db %00000011
 .db %10110111
 .db %00000011
 .db %11111110
 .db %11111100

train4:	;railroadpiece
 .db %00000000
 .db %11111111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %11111111
 .db %00000000

 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

 .db %00000000
 .db %11111111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %11111111
 .db %00000000

 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

rig:
 .db %01111111
 .db %11000000
 .db %11000000
 .db %01000000
 .db %11000000
 .db %11000000
 .db %01111111

 .db %11111111
 .db %01111111
 .db %01111111
 .db %11000000
 .db %01111111
 .db %01111111
 .db %11111111

 .db %11111111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %11111111

 .db %11111111
 .db %11111111
 .db %11111111
 .db %00000000
 .db %11111111
 .db %11111111
 .db %11111111

 .db %11111101
 .db %00000101
 .db %00000111
 .db %00000111
 .db %00000111
 .db %00000101
 .db %11111101

 .db %11111101
 .db %11111101
 .db %11111111
 .db %00000101
 .db %11111111
 .db %11111101
 .db %11111101

 .db %11111111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %11111111

 .db %11111111
 .db %11111111
 .db %11111111
 .db %00000000
 .db %11111111
 .db %11111111
 .db %11111111

 .db %11111111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %11111111

 .db %11111111
 .db %11111111
 .db %11111111
 .db %00000000
 .db %11111111
 .db %11111111
 .db %11111111

 .db %10000000
 .db %11110000
 .db %10011000
 .db %10011000
 .db %10011000
 .db %11110000
 .db %10000000

 .db %11110000
 .db %11111000
 .db %10101000
 .db %10101000
 .db %10101000
 .db %11111000
 .db %11110000

log:
 .db %01010101
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

 .db %11111111
 .db %11111111
 .db %00101001
 .db %00000000
 .db %00000000
 .db %10011110
 .db %11111111

 .db %01010101
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

 .db %11111111
 .db %11111111
 .db %11100110
 .db %00000000
 .db %00000000
 .db %00101101
 .db %11111111



;###################################
;===================================
;#####	GS ROUTINES
;===================================
;###################################

CloseGrey:
  res 2,(iy + $23)                ;disable user routine
  ld a,$3c                        ;restore screen to normal memory location
  out (0),a
  set graphdraw,(iy + graphflags) ;graph memory is 'dirty'
  ret                             ;return to main program

GreyscaleRoutineStart:
;  pop hl                         ;remove the calling routine from the stack - 
                                  ;we'll exit the routine in our own code
                                  ;without going through the default OS code

  ld bc,$3600                     ;b contains value to toggle link port with,
                                  ;c contains port to send value out of
  ld hl,GreyMem                   ;hl points to a memory location containing
                                  ;the interrupt counter

  dec (hl)                        ;decrease the interrupt counter... 
  jr z,SetCount3                  ;...and if it's zero goto SetCount3...
  inc hl                          ;...otherwise make hl point to current
                                  ;value of port 0 (port 0 is write only)
  ld a,(hl)                       ;load a with value of port 0
  xor b                           ;toggle it with b...
  out (c),a                       ;...send it out of port 0...
  ld (hl),a                       ;...and save it to memory

ExitInt:                          ;code to exit the interrupt

;  in a,(3)                        ;The following was copied (nearly) from
;  rra                             ;the ROM - it seems to handle the ON
;  ld a,c                          ;key. If it is left out the calculator
;  adc a,9                         ;may freeze, especially if the ON key;
;  out (3),a                       ;is pressed.
;  ld a,$0b
;  out (3),a

;  exx                             ;restore normal registers
;  ex af,af'
;  ei                              ;make sure interrupts are enabled
  ret;i                            ;return from interrupt

SetCount3:
  ld (hl),3                       ;set interrupt counter to 3
  jr ExitInt                      ;and return from the interrupt
gsr_end:

GreyMem:
.db $01, $3c

;===
frog:
.db %00110000,0
.db %00110000,0
.db %10110100,0
.db %01111000,0
.db %11001100,0


vopc:
.end



levelz:
	;76543210	;765 =liike, 4=liikes., 3=vri, 210=autoja
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000


 push hl
 push af
 push bc
 push de
 ld l,a
 xor a
 ld h,a
 ld bc,$0207
 ld (_curRow),bc
 call _dispAHL
 call _pause
 pop de
 pop bc
 pop af
 pop hl


;### unpack leveldata to lanedata (vopc - vopc+6)

 ld hl,(level)		;level datan alku
 ld de,lanedata
 ld b,6
movedirections:
 ld a,(hl)
 rra
 rra
 rra
 rra
 and %1111		;kaistan liike & liikesuunta
 ex de,hl
 ld (hl),a
 inc hl
 ex de,hl
 inc hl
 djnz movedirections



car11:	;a formula car
 .db %01011001
 .db %01011011
 .db %01011111
 .db %01111111
 .db %01011111
 .db %01011011
 .db %01011001

 .db %00111010
 .db %01011111
 .db %01100110
 .db %01111111
 .db %01100110
 .db %01011111
 .db %00111010

 .db %00001100
 .db %11101101
 .db %11110101
 .db %01111111
 .db %11110101
 .db %11101101
 .db %00001100

 .db %10001110
 .db %10001100
 .db %01101011
 .db %11111111
 .db %01101011
 .db %10001100
 .db %10001110


 call clrscrn
 ld hl,$fc00
 ld de,frog
 ld b,8
sammakot:
 push bc
  push hl
 ld b,5
 call putsprite
  pop hl
 inc hl
 ld b,5
 call putsprite
 dec hl
 call s16ba
 pop bc
 djnz sammakot


 call _pause
 jp exit


;### Draw lines between lanes

 ld hl,$ca70
 ld de,$80
 ld c,7
 ld a,%11111111
drawlines:
 rrca
 push hl
 ld b,16
drawlines2:
 ld (hl),a
 inc hl
 djnz drawlines2
 pop hl
 add hl,de
 dec c
 jr nz,drawlines



;====
print_a:
 ld de,0
 push bc
 ld (_penCol),bc
 ld b,a
print_a2:
 inc d
 ld a,10
 cp d
 jr nz,no10
 inc e
 ld d,0
no10:
 djnz print_a2
 ld a,e
 add a,48
 push de
 call _vputmap
 pop de
 pop bc
 ld a,4
 add a,c
 ld c,a
 ld (_penCol),bc
 ld a,d
 add a,48
 call _vputmap
 ret



 ld a,(timedel)
 inc a
 cp 150
 jr nz,no_time
 ld hl,(time_left)
 dec hl
 ld a,h
 or a
 jr z,no_time-1
 ld a,l
 or a
 jr z,no_time-1
 ld (time_left),hl
 ld bc,$0202
 call print_hl
 xor a
no_time:
 ld (timedel),a

 ld a,(cur_mode)
 cp 1
 jr nz,ltno_m1
 ld a,(surv_level)
 add a,48
 jr ltno_m1+3
ltno_m1:


